#if 0
  Siril 
  Copyright (C) 2005 Francois Meyer (dulle @ free.fr)
  Reference site is http://dulle.free.fr/alidade/siril.php

  Siril is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

#endif
#include <sys/types.h>
#include <sys/stat.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <stdio.h>
#include <complex.h>
#include <math.h>
#include <string.h>
#include <fftw3.h>
#include "callbacks.h"
#include "siril.h"
#include "Def_Math.h"
#include "Def_Wavelet.h"

static const char keywords[1][32]= {"working-directory"};

#define MAXTOKEN (1)

#define NOTOK (-1)
#define WD (0)

int isblank (int c);
char error_buffer[256];

extern cominfo com;

int reallocgfit(int x, int y){
	int nbdata=x*y;

	if (gfit.rx!=x || gfit .ry !=y){
		if((gfit.data=realloc(gfit.data,nbdata*3*sizeof(WORD)))==NULL){
			fprintf(stderr,"reallocgfit: error alloc fit1\n");
			return(1);
			}
		fprintf(stderr,"reallocgfit: x=%d y=%d nbdata=%d *3=%d\n", x, y, nbdata, x*y*3);
		gfit.pdata[RLAYER]=gfit.data;
		gfit.pdata[GLAYER]=gfit.data+nbdata;
		gfit.pdata[BLAYER]=gfit.data+nbdata+nbdata;
		}
	return 0;
	}

// Process the case of a void generic name : '' or ""
char *isempty(char *name){
	if ( !strcmp(name,"''") ){
		*name=0;
		}
	if ( !strcmp(name,"\"\"") ){
		*name=0;
		}
	return name;
	}

char *buildseqname(char  *seqprefix, char *filename, int index){
	isempty(com.seq.name);
	if (index>=0){
// do we need a fixed length index ?
		if (com.seq.fixed<=1){
			sprintf(com.format,"%%s%%s%%d");
			}
		else {
			sprintf(com.format,"%%s%%s%%.%dd", com.seq.fixed);
			}
		snprintf(filename, 255, com.format, seqprefix, com.seq.name, index);
		}
	else{
		sprintf(com.format,"%%s%%s");
		snprintf(filename, 255, com.format, seqprefix, com.seq.name);
		}
	return filename;
	}

char *buildfilename(char *name, int index){
	isempty(name);
// do we need a fixed length index ?
	if (com.seq.fixed<=1){
		sprintf(com.format,"%%s%%d");
		}
	else {
		sprintf(com.format,"%%s%%.%dd", com.seq.fixed);
		}
	snprintf(com.formname, 255, com.format, name, index);
	return com.formname;
	}

int findtype(char *filename, char *suf, int *type){
//
// extracts the extension of filename
// compares it to png, jpg, jpeg, bmp
// positions type to the corresponding entry
// returns the suffix in *suffix
//	
	char *suffix=filename;

	if((suffix=strrchr(filename,'.'))){
		*suffix=0;
		++suffix;
//		snprintf(error_buffer,255,"findtype: found that : %s.%s\n",filename,suffix);
//		siril_error(error_buffer,0);
		}
	else {
		snprintf(error_buffer,255,"findtype: Dont know how to manage %s.%s\n",filename,suffix);
		siril_error(error_buffer,0);
		return 1;
		}

	if(strstr(suffix,"png") || strstr(suffix,"PNG")){
		*type=TYPEPNG;
		}
	else {
		if(strstr(suffix,"jpg") || strstr(suffix,"JPG") 
				||strstr(suffix,"jpeg") || strstr(suffix,"JPEG")){
			*type=TYPEJPG;
			}
		else {
			if(strstr(suffix,"bmp") || strstr(suffix,"BMP")){
				*type=TYPEBMP;
				}
			else {
				snprintf(error_buffer,255,"Dont know hoq to convert %s.%s\n",
						filename,suffix);
				return 1;
				}
			}
		}
	strcpy(suf,".");
	strncat(suf,suffix,14);
//	snprintf(error_buffer,255,"findtype: type %d suf %s\n",*type,suffix);
//	siril_error(error_buffer,0);
	return 0;
	}	


int trytypefits(char *filename, char *suffix){
// concats filename and suffix
// tests whether the resulting file is either regular or 
// 	a symlink
// returns 0 if yes, 1 otherwise
//    
   	struct stat   sts;
	char copy[256];

        strncpy(copy,filename,255);
	snprintf(filename,255,"%s%s", copy, suffix);
	if ( stat (filename, & sts) != 0) {
		strncpy(filename,copy,255); // restore root file name
		return 1;
		}

	if (!(S_ISREG (sts.st_mode) || S_ISLNK(sts.st_mode))){
		strncpy(filename,copy,255); // restore root file name
		return 1;
		}
	return 0;
	}

int stat_file(char *filename, int *type){
//
// tests if filename is the canonical name of a known file type
// positions *type according to the result of the test
// 
	*type=TYPEUNDEF;
	if (!trytypefits(filename,"")){
		*type=TYPEFITS;
		return 0;
		}
	if (!trytypefits(filename,".fit")){
		*type=TYPEFITS;
		return 0;
		}	
	if (!trytypefits(filename,".fits")){
		*type=TYPEFITS;
		return 0;
		}

	if (!trytypefits(filename,".png")){
		*type=TYPEPNG;
		return 0;
		}

	if (!trytypefits(filename,".jpg")){
		*type=TYPEJPG;
		return 0;
		}

	if (!trytypefits(filename,".jpeg")){
		*type=TYPEJPG;
		return 0;
		}

	if (!trytypefits(filename,".bmp")){
		*type=TYPEBMP;
		return 0;
		}

	return(1);
	}

int seqseek(char *list[],char *seqlist[]){
	return 0;
	}

static int InitNextLine(FILE *in, char *line){
	char *read, *sharp;

	do {
		if ((read=fgets(line, 250, in))){
			sharp=strchr(line,'#');
#ifdef DEBUG
			fprintf(stderr, "avant: %s",line);
#endif
			if (sharp)
				*sharp=0;
#ifdef DEBUG
			fprintf(stderr, "apres: %s",line);
#endif
			}
		}
	while (!strlen(line) && read);
#ifdef DEBUG
	fprintf(stderr, "alafin: %s",line);
#endif
	return 0;
}


	
static int keywordscan(char *token){
	int i;
	
	for (i=0;i<MAXTOKEN;++i){
		if (strstr(token,keywords[i])){
				return i;
				}
		}
	return NOTOK;
	}

int readinitfile(void){
	FILE *config;
        char line[256];
        char token[256];
        char value[256];

        if (!com.initfile){
		return(1);
		}

        if ((config=fopen(com.initfile,"r"))==NULL){
		return(1);
		}
                
        while (!feof(config)){
		InitNextLine(config,line);
		sscanf(line, "%s %s", token,value);

		switch (keywordscan(token)){
			case WD:
				strncpy(com.wd,value,255);
				changedir(com.wd);
				break;

			default:
			case NOTOK:
				fprintf(stderr,"Unknown keyword %s in init file %s\n", token, com.initfile);
				break;
			}
		}
	return 0;
	}

int writeinitfile(void){
	FILE *initfile;

	initfile=fopen(com.initfile,"w+");
	if (initfile==NULL){
		perror("");
		fprintf(stderr,"Could not write init file %s\n", com.initfile);
		return 1;
		}
	fprintf(initfile,"%s %s\n",keywords[WD],com.wd);
	fclose(initfile);	
	return 0;
	}

int checkinitfile(void){
	char *home;
	int i=1;
   	struct stat   sts;
	char filename [255];

	home=getenv("HOME");

	if (com.initfile[0] == 0) {
		// no file given on command line, set initfile to default location
		snprintf(com.initfile,255,"%s/.siril/sirilrc",home);
		}
	else {
		// try to read the file given on command line
		if((i=readinitfile())){
			snprintf(com.initfile,255,"%s/.siril/sirilrc",home);
			}
		else {
			return 0;
			}
		}
// if the init file given on command line could not be read
// then try the default location
	if((i=readinitfile())){
		// if that fails, check and create the default ini file
		snprintf(filename,255,"%s/.siril", home);
		if ( stat (filename, &sts) != 0) {
			if(errno==ENOENT){
				if (mkdir(filename,0755)){
					fprintf(stderr,"Could not create dir %s, please check\n", filename);
					return 1;
					}
				return (writeinitfile());
				}
			}

		if (!(S_ISDIR (sts.st_mode))){
			fprintf(stderr,"There is a file named %s, that is not a directory.\
					Remove or rename it first\n", filename);
			exit (1);
			}
		}
	return 0;
	}

int siril_init(int argc, char *argv[]){
	getcwd(com.wd,255);
	checkinitfile();

	com.seq.active=FALSE;
	com.seq.number=0;
	com.seq.fixed=0;
	strncpy(com.seq.name,"",255);
	com.drawn=0;
	com.reglayer=GLAYER;
	com.zoom=NOZOOM;

	checkdir(com.wd);

	if(argc>1){
		readfits(argv[1],&gfit);
		display_filename(argv[1]);
		}
	return 0;
	}


